﻿var _interaction = app.scriptPreferences.userInteractionLevel;
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.INTERACT_WITH_ALL;

try {
	if (app.documents.length > 0)  check();
} catch (e) {
	alert (e)	
}
app.scriptPreferences.userInteractionLevel = _interaction;


function check() {
	var _dok = app.activeDocument;
	var _alleBilder = _dok.allGraphics;
	for (var i = 0; i < _alleBilder.length; i++) {
		var _bild = _alleBilder[i];
		var _bildRahmen = _bild.parent;
        _page = findPage(_bildRahmen);
        if (_page == null) continue;
		var _fehler = false;
		var _fehlerMeldung = "";
		if (_bild.geometricBounds[0] > _bildRahmen.geometricBounds[0]) {
				_fehlerMeldung= "Vertikaler Versatz oben\n";
				_fehler = true;
		 } 
		 if (_bild.geometricBounds[1] > _bildRahmen.geometricBounds[1]) {
				_fehlerMeldung= _fehlerMeldung + "Horizontaler Versatz links\n";
				_fehler = true;
		 }        
		if (_bild.geometricBounds[2] < _bildRahmen.geometricBounds[2]) {
				_fehlerMeldung = _fehlerMeldung + "Vertikaler Versatz unten\n";
				_fehler = true;
		 } 
		 if (_bild.geometricBounds[3] < _bildRahmen.geometricBounds[3]) {
				_fehlerMeldung= _fehlerMeldung+ "Horizontaler Versatz rechts\n";
				_fehler = true;
		 }        
		// Falls ein Fehler gefunden wurde und das bild auf einer seite platziert ist: ...
		if (_fehler) {
			app.select(_bildRahmen); 
			app.activeWindow.activePage  = _page;
			app.activeWindow.zoom(ZoomOptions.FIT_PAGE);
			alert (_bild.itemLink.name + "\n" + _fehlerMeldung);
			return;
		}
	}
}

// Diese Funktion liefert in allen InDesign Versionen die Seite auf der das Objekt platziert ist.
function findPage(theObj) {
     if (theObj.hasOwnProperty("baseline")) {
          theObj = theObj.parentTextFrames[0];
     }
     while (theObj != null) {
          if (theObj.hasOwnProperty ("parentPage")) return theObj.parentPage;
          var whatIsIt = theObj.constructor;
          switch (whatIsIt) {
               case Page : return theObj;
               case Character : theObj = theObj.parentTextFrames[0]; break;
               case Footnote :; // drop through
               case Cell : theObj = theObj.insertionPoints[0].parentTextFrames[0]; break;
               case Note : theObj = theObj.storyOffset; break;
               case XMLElement :  if (theObj.insertionPoints[0] != null)  { theObj =  theObj.insertionPoints[0].parentTextFrames[0]; break; }
               theObj = theObj.storyOffset; break;
               case Application : return null;
               default: theObj = theObj.parent;
          }
          if (theObj == null) return null;          
     }
     return theObj
} // end findPage